#!/usr/bin/perl

use strict;
use warnings;
#use Data::Dumper;
use POSIX qw( mktime );

# $Id: //depot/code/perl/vitality/MAIN/checker.pl#5 $

my $time=time();

sub expired {
	my $date = shift;
	my (undef, $y,$m,$d) = split( /^(\d{4})-(\d{1,2})-(\d{1,2})/, $date );
	my $et = mktime(0,1,0,$d,$m-1,$y-1900);

	# ignore entries unless they're 4 weeks old
	if( $et < ( $time - 60*60*24*7*4 ) ) {
		return 1;
	}
	else {
		return 0;
	}
}

my %data;

open( my $fh, "<", "data" ) || die "cannot open data file: $!";
open( my $rh, "<", "report" ) || die "cannot open report file: $!";

while( my $line = <$fh> ) {
	chomp $line;
	next if( $line =~ /^#/ );
	my ($date, $name, $points ) = split( /\s+/, $line, 3 );
	if( !defined( $date ) || !defined( $points ) || !defined( $name ) ) {
		print "Error reading line: \"$line\"\n";
		next;
	}
	$data{$date}->{ lc $name } += $points;
}
close( $fh );

my %report;
while( my $line = <$rh> ) {
	chomp $line;
	my ($date, $name, $points) = split( /\t+/, $line );
	$report{$date}->{ lc $name } = $points;
}
close( $rh );

#print Dumper( \%data );
#print Dumper( \%report );

foreach my $date ( keys %data ) {
	next if( !expired( $date ) );
	foreach my $name ( keys %{ $data{$date} } ) {
		if( !defined( $report{$date}->{$name} ) ) {
			print "$date:$name No report data\n";
			next;
		}
		if( $report{$date}->{$name} ne $data{$date}->{$name} ) {
			print "$date:$name Report data mismatch\n";
			next;
		}
	}
}

