#!/bin/sh

# $Id: //depot/code/perl/vitality/MAIN/vitality.sh#7 $

if test "$1x" = "x" ; then
	echo "usage: vitality.sh [member...]"
	echo "where [member...] is one or more numeric member numbers"
	exit
fi

P4PORT=localhost:1666
export P4PORT

touch ../report
p4 files ../report 2>&1 \
	| grep "no such file" >/dev/null 2>/dev/null \
	&& p4 add ../report
p4 edit -t text+w ../report
chmod 644 ../report

# we don't really want to make VUSER and VPASS exposed to all programs 
# in this script since it's potentially sensitive information </tin 
# foil>
VUSER=eneville VPASS=$( /usr/bin/gpg \
	-q \
	--for-your-eyes-only \
	--no-tty \
	-d \
	--use-agent \
	vitality.gpg ) \
	perl vitality.pl "$@" | tee ../report

if test $? -ne 0 ; then
	echo Failed to run pipe
	exit 1
fi
if test ! -s ../report ; then
	p4 revert ../report
	echo file is zero bytes
	exit 1
fi

p4 files ../report 2>&1 \
	| grep "no such file" >/dev/null 2>/dev/null \
	&& p4 submit -d `/bin/date --iso-8601=m` ../report
L=`p4 diff ../report | wc -l`
if test "$L" -gt 1 ; then
	change=$( p4 submit -d `/bin/date --iso-8601=m` ../report | grep '^Change' | sed -e 's/^Change //g' -e 's/ .*//g' );

	p4 describe -du "$change" | tee change_output
	cat change_output | /usr/sbin/sendmail $USER
else
	p4 revert ../report
fi
